Index: code/branches/doc/src/libraries/core/command/Functor.h
===================================================================
--- code/branches/doc/src/libraries/core/command/Functor.h	(revision 7347)
+++ code/branches/doc/src/libraries/core/command/Functor.h	(revision 7352)
@@ -27,4 +27,88 @@
  */
 
+/**
+    @file
+    @ingroup Command FunctorExecutor
+    @brief Definition of orxonox::Functor and its specialized subclasses, as well as the createFunctor() functions.
+
+    @anchor FunctorExample
+
+    Functors can be used to wrap function-pointers. While function-pointers have a very
+    complicated syntax in C++, Functors are always the same and you can call the wrapped
+    function-pointer independently of its parameter with arguments of type MultiType. These
+    arguments are then automatically converted to the right type.
+
+    To create a Functor, the helper function createFunctor() is used. It returns an instance
+    of orxonox::FunctorPtr which is simply a typedef of @ref orxonox::SharedPtr "SharedPtr<Functor>".
+    This means you don't have to delete the Functor after using it, because it is managed
+    by the SharedPtr.
+
+    Example:
+    @code
+    int myStaticFunction(int value)                         // Definition of a static function
+    {
+        return (value * 2);                                 // Return the double of the value
+    }
+
+    FunctorPtr functor = createFunctor(&myStaticFunction);  // Create a Functor
+
+    int result = (*functor)(5);                             // Calls the functor with value = 5, result == 10
+
+    int result = (*functor)("7");                           // Calls the functor with a string which is converted to an integer, result == 14
+    @endcode
+
+    Functors can also be used if you work with member-functions. In this case createFunctor()
+    returns an instance of orxonox::FunctorMemberPtr - this allows you to define the object
+    that will be used to call the function.
+
+    Example:
+    @code
+    class MyClass                                                   // Define a class
+    {
+        public:
+            MyClass(const std::string& text)                        // Constructor
+            {
+                this->text_ = text;
+            }
+
+            bool contains(const std::string& word)                  // Function that searches for "word" in "text"
+            {
+                return (this->text_.find(word) != std::string::npos);
+            }
+
+        private:
+            std::string text_;                                      // Member variable
+    };
+
+    MyClass* object = new MyClass("Hello World");                   // Create an object of type MyClass and set its text to "Hello World"
+
+    FunctorPtr functor = createFunctor(&MyClass:contains, object);  // Create a Functor (note the object!)
+
+    bool result = (*functor)("World");                              // result == true
+    bool result = (*functor)("test");                               // result == false
+    @endcode
+
+    Instead of assigning the object directly to the functor when creating it, you can also define
+    it at any later point or when you call the functor. Note however that this works only with
+    orxonox::FunctorMember.
+
+    @code
+    MyClass* object1 = new MyClass("Hello World");                  // Create an object
+    MyClass* object2 = new MyClass("this is a test");               // Create another object
+
+    FunctorMemberPtr functor = createFunctor(&MyClass:contains);    // Create a FunctorMember (note: no object this time)
+
+    bool result = (*functor)("World");                              // result == false and an error: "Error: Can't execute FunctorMember, no object set."
+
+    bool result = (*functor)(object1, "World");                     // result == true
+    bool result = (*functor)(object1, "test");                      // result == false
+    bool result = (*functor)(object2, "test");                      // result == true
+
+    functor->setObject(object1);                                    // Assign an object to the FunctorMember
+
+    bool result = (*functor)("World");                              // result == true (no error this time, because the object was set using setObject())
+    @endcode
+*/
+
 #ifndef _Functor_H__
 #define _Functor_H__
@@ -40,35 +124,52 @@
 namespace orxonox
 {
-    const unsigned int MAX_FUNCTOR_ARGUMENTS = 5;
-
+    const unsigned int MAX_FUNCTOR_ARGUMENTS = 5;   ///< The maximum number of parameters of a function that is supported by Functor
+
+    namespace detail
+    {
+        template <class T>
+        inline std::string _typeToString() { return "unknown"; }
+
+        template <> inline std::string _typeToString<void>()               { return "void"; }
+        template <> inline std::string _typeToString<int>()                { return "int"; }
+        template <> inline std::string _typeToString<unsigned int>()       { return "uint"; }
+        template <> inline std::string _typeToString<char>()               { return "char"; }
+        template <> inline std::string _typeToString<unsigned char>()      { return "uchar"; }
+        template <> inline std::string _typeToString<short>()              { return "short"; }
+        template <> inline std::string _typeToString<unsigned short>()     { return "ushort"; }
+        template <> inline std::string _typeToString<long>()               { return "long"; }
+        template <> inline std::string _typeToString<unsigned long>()      { return "ulong"; }
+        template <> inline std::string _typeToString<long long>()          { return "longlong"; }
+        template <> inline std::string _typeToString<unsigned long long>() { return "ulonglong"; }
+        template <> inline std::string _typeToString<float>()              { return "float"; }
+        template <> inline std::string _typeToString<double>()             { return "double"; }
+        template <> inline std::string _typeToString<long double>()        { return "longdouble"; }
+        template <> inline std::string _typeToString<bool>()               { return "bool"; }
+        template <> inline std::string _typeToString<std::string>()        { return "string"; }
+        template <> inline std::string _typeToString<Vector2>()            { return "Vector2"; }
+        template <> inline std::string _typeToString<Vector3>()            { return "Vector3"; }
+        template <> inline std::string _typeToString<Quaternion>()         { return "Quaternion"; }
+        template <> inline std::string _typeToString<ColourValue>()        { return "ColourValue"; }
+        template <> inline std::string _typeToString<Radian>()             { return "Radian"; }
+        template <> inline std::string _typeToString<Degree>()             { return "Degree"; }
+    }
+
+    /// Returns the name of type @a T as string.
     template <class T>
-    inline std::string _typeToString() { return "unknown"; }
-
-    template <> inline std::string _typeToString<void>()               { return ""; }
-    template <> inline std::string _typeToString<int>()                { return "int"; }
-    template <> inline std::string _typeToString<unsigned int>()       { return "uint"; }
-    template <> inline std::string _typeToString<char>()               { return "char"; }
-    template <> inline std::string _typeToString<unsigned char>()      { return "uchar"; }
-    template <> inline std::string _typeToString<short>()              { return "short"; }
-    template <> inline std::string _typeToString<unsigned short>()     { return "ushort"; }
-    template <> inline std::string _typeToString<long>()               { return "long"; }
-    template <> inline std::string _typeToString<unsigned long>()      { return "ulong"; }
-    template <> inline std::string _typeToString<long long>()          { return "longlong"; }
-    template <> inline std::string _typeToString<unsigned long long>() { return "ulonglong"; }
-    template <> inline std::string _typeToString<float>()              { return "float"; }
-    template <> inline std::string _typeToString<double>()             { return "double"; }
-    template <> inline std::string _typeToString<long double>()        { return "longdouble"; }
-    template <> inline std::string _typeToString<bool>()               { return "bool"; }
-    template <> inline std::string _typeToString<std::string>()        { return "string"; }
-    template <> inline std::string _typeToString<Vector2>()            { return "Vector2"; }
-    template <> inline std::string _typeToString<Vector3>()            { return "Vector3"; }
-    template <> inline std::string _typeToString<Quaternion>()         { return "Quaternion"; }
-    template <> inline std::string _typeToString<ColourValue>()        { return "ColourValue"; }
-    template <> inline std::string _typeToString<Radian>()             { return "Radian"; }
-    template <> inline std::string _typeToString<Degree>()             { return "Degree"; }
-
-    template <class T>
-    inline std::string typeToString() { return _typeToString<typename Loki::TypeTraits<T>::UnqualifiedReferredType>(); }
-
+    inline std::string typeToString() { return detail::_typeToString<typename Loki::TypeTraits<T>::UnqualifiedReferredType>(); }
+
+    /**
+        @brief The Functor classes are used to wrap function pointers.
+
+        Function-pointers in C++ have a pretty complicated syntax and you can't store
+        and call them unless you know the exact type. A Functor can be used to wrap
+        a function-pointer and to store it independent of its type. You can also call
+        it independently of its parameters by passing the arguments as MultiType. They
+        are converted automatically to the right type.
+
+        Functor is a pure virtual base class.
+
+        @see See @ref FunctorExample "Functor.h" for some examples.
+    */
     class _CoreExport Functor
     {
@@ -76,4 +177,5 @@
             struct Type
             {
+                /// Defines the type of a function (static or member)
                 enum Enum
                 {
@@ -84,33 +186,35 @@
 
         public:
+            /// Calls the function-pointer with up to five arguments. In case of a member-function, the assigned object-pointer is used to call the function. @return Returns the return-value of the function (if any; MT_Type::Null otherwise)
             virtual MultiType operator()(const MultiType& param1 = MT_Type::Null, const MultiType& param2 = MT_Type::Null, const MultiType& param3 = MT_Type::Null, const MultiType& param4 = MT_Type::Null, const MultiType& param5 = MT_Type::Null) = 0;
 
+            /// Creates a new instance of Functor with the same values like this (used instead of a copy-constructor)
             virtual FunctorPtr clone() = 0;
 
+            /// Returns the type of the function: static or member.
             virtual Type::Enum getType() const = 0;
+            /// Returns the number of parameters of the function.
             virtual unsigned int getParamCount() const = 0;
+            /// Returns true if the function has a return-value.
             virtual bool hasReturnvalue() const = 0;
 
-            virtual std::string getTypenameParam(unsigned int param) const = 0;
+            /// Returns the type-name of the parameter with given index (the first parameter has index 0).
+            virtual std::string getTypenameParam(unsigned int index) const = 0;
+            /// Returns the type-name of the return-value.
             virtual std::string getTypenameReturnvalue() const = 0;
 
-            virtual void evaluateParam(unsigned int index, MultiType& param) const = 0;
-
-            virtual void setRawObjectPointer(void* object) {}
-            virtual void* getRawObjectPointer() const { return 0; }
-
-            template <class F>
-            inline bool setFunction(F* function)
-            {
-                if (this->getFullIdentifier() == typeid(F*))
-                {
-                    modifyFunctor(this, function);
-                    return true;
-                }
-                return false;
-            }
-
+            /// Converts a given argument to the type of the parameter with given index (the first parameter has index 0).
+            virtual void evaluateArgument(unsigned int index, MultiType& argument) const = 0;
+
+            /// Assigns an object-pointer to the functor which is used to execute a member-function.
+            virtual void setRawObjectPointer(void* object) = 0;
+            /// Returns the object-pointer.
+            virtual void* getRawObjectPointer() const = 0;
+
+            /// Returns the full identifier of the function-pointer which is defined as typeid(@a F), where @a F is the type of the stored function-pointer. Used to compare functors.
             virtual const std::type_info& getFullIdentifier() const = 0;
+            /// Returns an identifier of the header of the function (doesn't include the function's class). Used to compare functors.
             virtual const std::type_info& getHeaderIdentifier() const = 0;
+            /// Returns an identifier of the header of the function (doesn't include the function's class), but regards only the first @a params parameters. Used to compare functions if an Executor provides default-values for the other parameters.
             virtual const std::type_info& getHeaderIdentifier(unsigned int params) const = 0;
     };
@@ -118,4 +222,5 @@
     namespace detail
     {
+        // helper class to determine if a functor is static or not
         template <class O>
         struct FunctorTypeStatic
@@ -126,14 +231,29 @@
     }
 
+    /**
+        @brief FunctorMember is a child class of Functor and expands it with an object-pointer, that
+        is used for member-functions, as well as an overloaded execution operator.
+
+        @param O The type of the function's class (or void if it's a static function)
+
+        Note that FunctorMember is also used for static functions, but with T = void. FunctorStatic
+        is a typedef of FunctorMember<void>. The void* object-pointer is ignored in this case.
+
+        @see See @ref FunctorExample "Functor.h" for some examples.
+    */
     template <class O>
     class FunctorMember : public Functor
     {
         public:
+            /// Constructor: Stores the object-pointer.
             FunctorMember(O* object = 0) : object_(object) {}
 
+            /// Calls the function-pointer with up to five arguments and an object. In case of a static-function, the object can be NULL. @return Returns the return-value of the function (if any; MT_Type::Null otherwise)
             virtual MultiType operator()(O* object, const MultiType& param1 = MT_Type::Null, const MultiType& param2 = MT_Type::Null, const MultiType& param3 = MT_Type::Null, const MultiType& param4 = MT_Type::Null, const MultiType& param5 = MT_Type::Null) = 0;
 
+            // see Functor::operator()()
             MultiType operator()(const MultiType& param1 = MT_Type::Null, const MultiType& param2 = MT_Type::Null, const MultiType& param3 = MT_Type::Null, const MultiType& param4 = MT_Type::Null, const MultiType& param5 = MT_Type::Null)
             {
+                // call the function if it is static or if an object was assigned
                 if (detail::FunctorTypeStatic<O>::result || this->object_)
                     return (*this)(this->object_, param1, param2, param3, param4, param5);
@@ -145,43 +265,67 @@
             }
 
+            // see Functor::getType()
             Functor::Type::Enum getType() const
                 { return detail::FunctorTypeStatic<O>::result ? Functor::Type::Static : Functor::Type::Member; }
 
+            /// Assigns an object-pointer to the functor which is used to execute a member-function.
             inline void setObject(O* object)
                 { this->object_ = object;}
+            /// Returns the object-pointer.
             inline O* getObject() const
                 { return this->object_; }
 
+            // see Functor::setRawObjectPointer()
             inline void setRawObjectPointer(void* object)
                 { this->object_ = (O*)object; }
+            // see Functor::getRawObjectPointer()
             inline void* getRawObjectPointer() const
                 { return this->object_; }
 
         protected:
-            O* object_;
+            O* object_;     ///< The stored object-pointer, used to execute a member-function (or NULL for static functions)
     };
 
+    /// FunctorStatic is just a typedef of FunctorMember with @a T = void.
     typedef FunctorMember<void> FunctorStatic;
 
+    /**
+        @brief FunctorPointer is a child class of FunctorMember and expands it with a function-pointer.
+        @param F The type of the function-pointer
+        @param O The type of the function's class (or void if it's a static function)
+
+        The template FunctorPointer has an additional template parameter that defines the type
+        of the function-pointer. This can be handy if you want to get or set the function-pointer.
+        You can then use a static_cast to cast a Functor to FunctorPointer if you know the type
+        of the function-pointer.
+
+        However FunctorPointer is not aware of the types of the different parameters or the
+        return value.
+    */
     template <class F, class O = void>
     class FunctorPointer : public FunctorMember<O>
     {
         public:
+            /// Constructor: Initializes the base class and stores the function-pointer.
             FunctorPointer(F functionPointer, O* object = 0) : FunctorMember<O>(object), functionPointer_(functionPointer) {}
 
+            /// Changes the function-pointer.
             inline void setFunction(F functionPointer)
                 { this->functionPointer_ = functionPointer; }
+            /// Returns the function-pointer.
             inline F getFunction() const
                 { return this->functionPointer_; }
 
+            // see Functor::getFullIdentifier()
             const std::type_info& getFullIdentifier() const
                 { return typeid(F); }
 
         protected:
-            F functionPointer_;
+            F functionPointer_;     ///< The stored function-pointer
     };
 
     namespace detail
     {
+        // Helper class to get the type of the function pointer with the given class, parameters, return-value, and constness
         template <class R, class O, bool isconst, class P1, class P2, class P3, class P4, class P5> struct FunctionPointer                                            { typedef R (O::*Type)(P1, P2, P3, P4, P5); };
         template <class R, class O, class P1, class P2, class P3, class P4, class P5>               struct FunctionPointer<R, O, false, P1, P2, P3, P4, P5>           { typedef R (O::*Type)(P1, P2, P3, P4, P5); };
@@ -204,4 +348,5 @@
         template <class R>                                                   struct FunctionPointer<R, void, false, void, void, void, void, void> { typedef R (*Type)(); };
 
+        // Helper class, used to call a function-pointer with a given object and parameters and to return its return-value (if available)
         template <class R, class O, bool isconst, class P1, class P2, class P3, class P4, class P5> struct FunctorCaller                                              { static inline MultiType call(typename detail::FunctionPointer<R, O, isconst, P1, P2, P3, P4, P5>::Type functionPointer, O* object, const MultiType& param1, const MultiType& param2, const MultiType& param3, const MultiType& param4, const MultiType& param5) { return (object->*functionPointer)(param1, param2, param3, param4, param5); } };
         template <class R, class O, bool isconst, class P1, class P2, class P3, class P4>           struct FunctorCaller<R, O, isconst, P1, P2, P3, P4, void>         { static inline MultiType call(typename detail::FunctionPointer<R, O, isconst, P1, P2, P3, P4, void>::Type functionPointer, O* object, const MultiType& param1, const MultiType& param2, const MultiType& param3, const MultiType& param4, const MultiType& param5) { return (object->*functionPointer)(param1, param2, param3, param4); } };
@@ -229,8 +374,10 @@
         template <bool isconst>                                                   struct FunctorCaller<void, void, isconst, void, void, void, void, void> { static inline MultiType call(typename detail::FunctionPointer<void, void, isconst, void, void, void, void, void>::Type functionPointer, void*, const MultiType& param1, const MultiType& param2, const MultiType& param3, const MultiType& param4, const MultiType& param5) { (*functionPointer)(); return MT_Type::Null; } };
 
+        // Helper class, used to identify the header of a function-pointer (independent of its class)
         template <class R, class P1, class P2, class P3, class P4, class P5>
         struct FunctorHeaderIdentifier
         {};
 
+        // Helper class to determine if a function has a returnvalue
         template <class T>
         struct FunctorHasReturnvalue
@@ -240,4 +387,5 @@
         { enum { result = false }; };
 
+        // Helper class to count the number of parameters
         template <class P1, class P2, class P3, class P4, class P5>
         struct FunctorParamCount
@@ -260,10 +408,32 @@
     }
 
+    /**
+        @brief FunctorTemplate is a child class of FunctorPointer and implements all functions
+        that need to know the exact types of the parameters, return-value, and class.
+
+        @param R The type of the return-value of the function
+        @param O The class of the function
+        @param isconst True if the function is a const member-function
+        @param P1 The type of the first parameter
+        @param P2 The type of the second parameter
+        @param P3 The type of the third parameter
+        @param P4 The type of the fourth parameter
+        @param P5 The type of the fifth parameter
+
+        This template has many parameters and is usually not used directly. It is created by
+        createFunctor(), but only the base-classes Functor, FunctorMember, and FunctorPointer
+        are used directly. It implements all the virtual functions that are declared by its
+        base classes.
+
+        All template arguments can be void.
+    */
     template <class R, class O, bool isconst, class P1, class P2, class P3, class P4, class P5>
     class FunctorTemplate : public FunctorPointer<typename detail::FunctionPointer<R, O, isconst, P1, P2, P3, P4, P5>::Type, O>
     {
         public:
+            /// Constructor: Initializes the base class.
             FunctorTemplate(typename detail::FunctionPointer<R, O, isconst, P1, P2, P3, P4, P5>::Type functionPointer, O* object = 0) : FunctorPointer<typename detail::FunctionPointer<R, O, isconst, P1, P2, P3, P4, P5>::Type, O>(functionPointer, object) {}
 
+            // see FunctorMember::operator()()
             MultiType operator()(O* object, const MultiType& param1 = MT_Type::Null, const MultiType& param2 = MT_Type::Null, const MultiType& param3 = MT_Type::Null, const MultiType& param4 = MT_Type::Null, const MultiType& param5 = MT_Type::Null)
             {
@@ -271,4 +441,5 @@
             }
 
+            // see Functor::clone()
             FunctorPtr clone()
             {
@@ -276,16 +447,18 @@
             }
 
-            void evaluateParam(unsigned int index, MultiType& param) const
+            // see Functor::evaluateArgument()
+            void evaluateArgument(unsigned int index, MultiType& argument) const
             {
                 switch (index)
                 {
-                    case 0: param.convert<P1>(); break;
-                    case 1: param.convert<P2>(); break;
-                    case 2: param.convert<P3>(); break;
-                    case 3: param.convert<P4>(); break;
-                    case 4: param.convert<P5>(); break;
+                    case 0: argument.convert<P1>(); break;
+                    case 1: argument.convert<P2>(); break;
+                    case 2: argument.convert<P3>(); break;
+                    case 3: argument.convert<P4>(); break;
+                    case 4: argument.convert<P5>(); break;
                 }
             }
 
+            // see Functor::getParamCount()
             unsigned int getParamCount() const
             {
@@ -293,4 +466,5 @@
             }
 
+            // see Functor::hasReturnvalue()
             bool hasReturnvalue() const
             {
@@ -298,7 +472,8 @@
             }
 
-            std::string getTypenameParam(unsigned int param) const
-            {
-                switch (param)
+            // see Functor::getTypenameParam()
+            std::string getTypenameParam(unsigned int index) const
+            {
+                switch (index)
                 {
                     case 0:  return typeToString<P1>();
@@ -311,4 +486,5 @@
             }
 
+            // see Functor::getTypenameReturnvalue()
             std::string getTypenameReturnvalue() const
             {
@@ -316,4 +492,5 @@
             }
 
+            // see Functor::getHeaderIdentifier()
             const std::type_info& getHeaderIdentifier() const
             {
@@ -321,4 +498,5 @@
             }
 
+            // see Functor::getHeaderIdentifier(unsigned int)
             const std::type_info& getHeaderIdentifier(unsigned int params) const
             {
